/*
 * Constraints.h
 *
 *  Created on: Jul 8, 2015
 *      Author: Andre Dozier
 */

#ifndef CONSTRAINTS_H_
#define CONSTRAINTS_H_

#include <vector>
#include <stdexcept>
using namespace std;

#include "Constraint.h"

class Constraints {

	vector<Constraint> _constraints;

public:

	vector<bool> otherIsState;

	Constraints() {
	}

	void add(Constraint& constraint, bool isState) {
		_constraints.push_back(constraint);
		otherIsState.push_back(isState);
	}

	bool satisfied(long long selfI, long long otherI) {

		int dim;
		for (dim = 0; dim < _constraints.size(); dim++) {
			if (!_constraints[dim].satisfied(selfI, otherI))
				return false;
		}
		return true;
	}

};

#endif /* CONSTRAINTS_H_ */
