/*
 * DyproSolutionAtTime.h
 *
 *  Created on: Apr 27, 2015
 *      Author: Andre Dozier
 */

#ifndef DYPROSOLUTIONATTIME_H_
#define DYPROSOLUTIONATTIME_H_

#include <vector>
#include <cmath>
#include <stdexcept>
#include <iostream>
#include "Bounds.h"
#include "DyproSolutionPoint.h"
#include "LinearGrid.h"
using namespace std;

class DyproSolutionAtTime {

public:

	// public instance variables
	DyproSolutionPoint init;
	vector<DyproSolutionPoint> solution;

	// constructor
	DyproSolutionAtTime();
	void resize(int t, long long stateCardinality, int nStateVars,
			int nDecisionVars, int numRndVarDims, double initValue);

	// decisions
	DyproSolutionPoint& operator[](long long);

	// cardinality
	long long size() {
		return solution.size();
	}

	// print
	int save(ostream& o, int t, int maxPrints = 0, int nPrints = 0);
	void load(istream& fs);

};

#endif /* DYPROSOLUTIONATTIME_H_ */
