/*
 * DyproSolutionPoint.h
 *
 *  Created on: Feb 2, 2015
 *      Author: Andre Dozier
 */

#ifndef DyproSolutionPoint_H_
#define DyproSolutionPoint_H_

#include <vector>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include "SnappedValue.h"
using namespace std;

class DyproSolutionPoint {

public:

	// instance variables
	long long decision_i;
	long long state_i;
	vector<double> decision;
	vector<double> state;
	vector<double> rndVar;
	SnappedValue nextState;
	int t;
	double value;
	double risk_LowState;
	double risk_HighState;
	double risk_InfValue;
	bool acceptableRisk;

	// constructors
	DyproSolutionPoint();
	DyproSolutionPoint(int stateDim, int decisionDim, int randomVarDim);
	~DyproSolutionPoint();

	// member functions
	void resize(int stateDim, int decisionDim, int randomVarDim);
	void saveHeaders(ostream& o);
	void save(ostream& o);
	void saveNext(ostream& o, double totalValue);
	void load(istream& fs);
};

#endif /* DyproSolutionPoint_H_ */
