/*
 * LinearGrid.h
 *
 *  Created on: Jan 31, 2015
 *      Author: Andre Dozier
 */

#ifndef LINEARGRID_H_
#define LINEARGRID_H_


#include <vector>
#include "LinearSpace.h"
#include "CartesianProduct.h"
#include "SnappedValue.h"
using namespace std;



/**
 * Associates values with each element of a Cartesian product. Values within
 * each dimension form a linear space.
 */
class LinearGrid: public CartesianProduct {
private:
	vector<LinearSpace> _linspaces;

public:

	// functions
	LinearGrid();
	LinearGrid(vector<LinearSpace>&);

	// member functions for constructing
	void addLinearSpace(LinearSpace);
	void addLinearSpaces(vector<LinearSpace>&);

	// member functions for snapping
	void snap(SnappedValue&);

	// properties
	vector<double> getMax();
	vector<double> getMin();

};





#endif /* LINEARGRID_H_ */
