/*
 * ObjectiveDirection.h
 *
 *  Created on: Feb 6, 2015
 *      Author: Andre Dozier
 */

#ifndef OBJECTIVEDIRECTION_H_
#define OBJECTIVEDIRECTION_H_

#include <map>
#include <cfloat>
#include <string>
#include "DyproSolutionPoint.h"
using namespace std;

static const double MAXVALUE = DBL_MAX;

enum ObjectiveDirection {
	Minimum = 1, Maximum = 2
};

static map<string, ObjectiveDirection> objDirectionFromString = { { "minimum",
		Minimum }, { "maximum", Maximum } };

class ObjectiveDirector {
public:
	double worstValue;
	ObjectiveDirector(double theWorstValue) {
		worstValue = theWorstValue;
	}
	virtual ~ObjectiveDirector() {
	}
	virtual void choose(DyproSolutionPoint&, DyproSolutionPoint&, bool*) = 0;
	static ObjectiveDirector* select(ObjectiveDirection);
	ObjectiveDirector* operator =(ObjectiveDirection a) {
		return select(a);
	}
};

class ObjectiveMinimizer: public ObjectiveDirector {
public:
	ObjectiveMinimizer() :
			ObjectiveDirector(MAXVALUE) {
	}
	void choose(DyproSolutionPoint&, DyproSolutionPoint&, bool*);
};

class ObjectiveMaximizer: public ObjectiveDirector {
public:
	ObjectiveMaximizer() :
			ObjectiveDirector(-MAXVALUE) {
	}
	void choose(DyproSolutionPoint&, DyproSolutionPoint&, bool*);
};

#endif /* OBJECTIVEDIRECTION_H_ */
