/*
 * ProbabilityWeightedGrid.h
 *
 *  Created on: Feb 2, 2015
 *      Author: Andre Dozier
 */

#ifndef PROBABILITYWEIGHTEDSET_H_
#define PROBABILITYWEIGHTEDSET_H_

#include <vector>
#include <stdexcept>
#include <cmath>
#include <numeric>
#include <iostream>
#include "Timeseries.h"
using namespace std;

class ProbabilityWeightedSet {
	Timeseries _realizations;
	vector<double> _probabilities;

public:
	int ndim;

	// constructor
	ProbabilityWeightedSet();
	ProbabilityWeightedSet(Timeseries&, vector<double>&);

	// member functions
	long long size();
	vector<double>& getVar(long long);
	double getProbability(long long);
	vector<double>& realize(double cumProbability);

	// static XML reader
	static ProbabilityWeightedSet fromXML(xml_node<> *node);
};

#endif /* PROBABILITYWEIGHTEDSET_H_ */
