/*
 * SnappedValue.h
 *
 *  Created on: Feb 3, 2015
 *      Author: Andre Dozier
 */

#ifndef SNAPPEDVALUE_H_
#define SNAPPEDVALUE_H_

#include <vector>
#include <climits>
#include <iostream>
using namespace std;

class SnappedValue {

public:

	// instance variables
	vector<long long> indices;
	vector<double> value;
	vector<double> originalValue;
	long long flatIndex;
	int ndim;
	bool hasLow;
	bool hasHigh;
	bool allInside;

	// constructors
	SnappedValue() {
		ndim = 0;
		reset();
	}

	SnappedValue(int numdim) {
		ndim = numdim;
		reset();
		resize(numdim);
	}

	~SnappedValue() {
	}

	void reset() {
		flatIndex = -1;
		allInside = true;
		hasLow = false;
		hasHigh = false;
	}

	void resize(int ndim) {
		indices.resize(ndim, 0);
		value.resize(ndim, 0);
		originalValue.resize(ndim, 0);
	}

	void setIndex(int dim, long long index, long long maxsize) {
		if (index < 0) {
			hasLow = true;
			allInside = false;
			indices[dim] = -1;
		} else if (index >= maxsize) {
			hasHigh = true;
			allInside = false;
			indices[dim] = -1;
		} else {
			indices[dim] = index;
		}
	}

};

#endif /* SNAPPEDVALUE_H_ */
