/*
 * StopWatch.h
 *
 *  Created on: Feb 19, 2015
 *      Author: Andre Dozier
 */

#ifndef STOPWATCH_H_
#define STOPWATCH_H_

#pragma once
#include <ctime>
#include <ratio>
#include <chrono>

using namespace std;
using namespace chrono;

class StopWatch {
private:

	//clock_t start;
	high_resolution_clock::time_point start;

	//clock_t finish;
	high_resolution_clock::time_point finish;

public:

	double seconds() {
		duration<double> d = duration_cast<duration<double> >(finish - start);
		return d.count();
	}

	void Start() {
		start = high_resolution_clock::now();
	}

	double Stop() {
		finish = high_resolution_clock::now();
		return seconds();
	}

};

#endif /* STOPWATCH_H_ */
