/*
 * Timeseries.h
 *
 *  Created on: Feb 12, 2015
 *      Author: Andre Dozier
 */

#ifndef TIMESERIES_H_
#define TIMESERIES_H_

#include <vector>
#include <cstdint>
#include <stdexcept>
#include <random>
#include <cstdlib>
#include <time.h>
#include <iostream>
#include "rapidxml.hpp"
#include "DyproUtils.h"
using namespace std;
using namespace rapidxml;

class Timeseries {

private:

	vector<vector<double> > _values;
	unsigned int _nTimesteps;
	unsigned int _nVars;

public:

	// constructor
	Timeseries();

	// properties
	long long size();
	unsigned int getNumVars();
	unsigned int getNumTimesteps();
	vector<double>& operator[](int t);

	// member functions
	void resize(int nTimesteps, int nVars);

	// static from string
	static Timeseries fromXML(xml_node<> *node);
};

#endif /* TIMESERIES_H_ */
